various fixes
authorIan Kelling <ian@iankelling.org>
Wed, 6 Nov 2019 03:47:51 +0000 (22:47 -0500)
committerIan Kelling <ian@iankelling.org>
Wed, 6 Nov 2019 03:47:51 +0000 (22:47 -0500)
avoid sudo -i where possible because it starts another login shell,
which doesn't know if its a part of a conditional and will do
independent error printing which is confusing.

brc
brc2
distro-begin
distro-end
dynamic-ip-update
system-status

diff --git a/brc b/brc
index f9439887573b4f0eed84950526c8ada10ae265f6..556c5ef04e743bb2208cc54dd7ae3d7cd1569cbe 100644 (file)
--- a/brc
+++ b/brc
@@ -12,6 +12,18 @@ elif [[ -s ~/.iank/err ]]; then
   source ~/.iank/err
 fi
 
+t2() {
+  echo t2
+  popd
+  grep sdf sdfd
+  echo wtf
+}
+t1() {
+  echo t1
+  trap
+  t2 a b c
+}
+
 # * settings
 
 CDPATH=.
@@ -527,12 +539,12 @@ faf() { # find all files. use -L to follow symlinks
 # mail related
 frozen() {
   rm -rf /tmp/frozen
-  s mailq |gr frozen|awk '{print $3}' | while read -r id; do
-    s exim -Mvl $id
+  sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
+    sudo exim -Mvl $id
     echo
-    s exim -Mvh $id
+    sudo exim -Mvh $id
     echo
-    s exim -Mvb $id
+    sudo exim -Mvb $id
     echo -e '\n\n##############################\n'
   done | tee -a /tmp/frozen
 }
@@ -544,7 +556,7 @@ frozenrm() {
   done < <(s mailq)
   echo "sleeping for 2 in case you change your mind"
   sleep 2
-  s exim -Mrm "${ids[@]}"
+  sudo exim -Mrm "${ids[@]}"
 }
 
 funce() {
@@ -670,7 +682,7 @@ hub() {
     wget -P /a/opt $up
     tar -C /a/opt -zxf /a/opt/$uptar
     rm -f /a/opt/$uptar
-    s /a/opt/$updir/install
+    sudo /a/opt/$updir/install
   fi
 
   # save token across computers
@@ -715,7 +727,7 @@ ifn() {
 }
 
 ipdrop() {
-  s iptables -A INPUT -s $1 -j DROP
+  sudo iptables -A INPUT -s $1 -j DROP
 }
 
 
@@ -930,7 +942,7 @@ rlu() { # [OPTS] HOST PATH
   # rync here uses checksum instead of time so we dont mess with
   # unison relying on time as much. g is for group, same reason
   # to keep up with unison.
-  s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
+  sudo rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
 }
 
 rmstrips() {
@@ -948,7 +960,7 @@ s() {
   #
   if [[ $EUID != 0 || $1 == -* ]]; then
     # shellcheck disable=SC2034
-    SUDOD="$PWD" sudo -i "$@"
+    SUDOD="$PWD" command sudo -i "$@"
   else
     "$@"
   fi
@@ -980,7 +992,7 @@ complete -F _root_command s sb
 
 
 ser() {
-  local s; [[ $EUID != 0 ]] && s=s
+  local s; [[ $EUID != 0 ]] && s=sudo
   if type -p systemctl &>/dev/null; then
     $s systemctl $1 $2
   else
@@ -1037,7 +1049,7 @@ sk() {
   # 2119: Functions with optional args get bad warnings when none are passed.
   # 2033: too many false positives for thing that will never work, passing shell function to find.
   # i had -x as an arg, but debian testing(stretch) doesn\'t support it
-  shellcheck -x -e 2086,2046,2068,2119,2033 "$@"
+  shellcheck -x -e 2086,2046,2068,2119,2033 "$@" || return $?
   # had this before. not sure what it is 2119
 }
 
@@ -1171,7 +1183,7 @@ psnetns() {
   local x netns
   netns=$1
   ps -w | head -n 1
-  s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
+  sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
     while read -r l; do
       x=$(ps -w --no-headers -p $l);
       if [[ $x ]]; then echo "$x"; else echo $l; fi;
@@ -1190,10 +1202,10 @@ vm-set-listen(){
   t=$(mktemp)
   local vm=$1
   local ip=$2
-  s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
+  sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
     sed -r "s/listen='[^']+/listen='$ip/"> $t
-  s virsh undefine $vm
-  s virsh define $t
+  sudo virsh undefine $vm
+  sudo virsh define $t
 }
 
 
diff --git a/brc2 b/brc2
index df695d2157336734a926e88f940bc0e730b2b1a4..3f0e9ec06504d50d2f43289e9ebf2a423196a0be 100644 (file)
--- a/brc2
+++ b/brc2
@@ -100,8 +100,8 @@ set -e
 conflink
 f=/var/lib/bind/db.b8.nz
 ser stop bind9
-s rm -fv $f.jnl
-s install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
+sudo rm -fv $f.jnl
+sudo install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
 ser restart bind9
 EOF
   done
@@ -659,21 +659,21 @@ net-dev-info() {
   hr
   e "s lshw -C network"
   hr
-  s lshw -C network
+  sudo lshw -C network
 }
 
 nk() {
   ser stop NetworkManager
   ser stop dnsmasq
-  s resolvconf -d NetworkManager
+  sudo resolvconf -d NetworkManager
   ser start dnsmasq
-  s ifup br0
+  sudo ifup br0
 }
 ngo() {
-  s ifdown br0
+  sudo ifdown br0
   ser start NetworkManager
   sleep 4
-  s nmtui-connect
+  sudo nmtui-connect
 }
 
 otp() {
@@ -746,8 +746,8 @@ pumpa() {
 #rbp() { rbt post -o "$@"; }
 
 rebr() {
-  s ifdown br0
-  s ifup br0
+  sudo ifdown br0
+  sudo ifup br0
 }
 
 resolvcat() {
@@ -860,7 +860,7 @@ spd() {
 }
 
 spend() {
-  s systemctl suspend
+  sudo systemctl suspend
 }
 
 # ssh, copy my universal config over if needed.
@@ -945,7 +945,6 @@ sl() {
       done
     fi
   else
-    dorsync=true
     # use this weird yes thing to ensure we know ssh succeeded
     if ! tmp=$(command ssh "${args[@]}" "$remote" "if test -e /a/bin/ds/.bashrc -a -L .bashrc; then echo yes; fi"); then
       echo failed sl test. doing plain ssh -v
@@ -954,13 +953,12 @@ sl() {
     if [[ $tmp == yes ]]; then
       type=a
     else
+      dorsync=true
       type=b
     fi
   fi
-  if [[ $type == b ]] && $dorsync; then
-    if ! RSYNC_RSH="ssh ${args[*]}" rsync -rptL /b/ds/sl/.iank "$remote":; then
-      echo WARNING: rsync failed. remove $sshinfo to try again
-    fi
+  if $dorsync; then
+    RSYNC_RSH="ssh ${args[*]}" rsync -rptL /b/ds/sl/.iank "$remote":
   fi
   if $dorsync || ! $haveinfo; then
     sshinfo=/p/sshinfo/$now$type"$remote"
@@ -968,9 +966,6 @@ sl() {
     chmod 666 $sshinfo
   fi
   if [[ $type == b ]]; then
-    if $dorsync; then
-      RSYNC_RSH="ssh ${args[*]}" rsync -rptL /b/ds/sl/.iank "$remote":
-    fi
     if (( ${#@} )); then
 
       # Theres a couple ways to do this. im not sure whats best,
@@ -1132,13 +1127,13 @@ vpn() {
 
   [[ $1 ]] || { echo need arg; return 1; }
   journalctl --unit=$vpn_service@$1 -f -n0 &
-  s systemctl start $vpn_service@$1
+  sudo systemctl start $vpn_service@$1
   # sometimes the ask-password agent does not work and needs a delay.
   sleep .5
   # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=779240
   # noticed around 8-2017 after update from around stretch release
   # on debian testing, even though the bug is much older.
-  s systemd-tty-ask-password-agent
+  sudo systemd-tty-ask-password-agent
 }
 
 vpnoff() {
@@ -1148,7 +1143,7 @@ vpnoff() {
   else
     local vpn_service=openvpn
   fi
-  s systemctl stop $vpn_service@$1
+  sudo systemctl stop $vpn_service@$1
 }
 vpnoffc() { # vpn off client
   ser stop openvpn-nn@client
index 75b9b05942ce0ae042d0cd3b188bdfcb2f1a0317..0744a1b07861d56739d972b77e38181da957b8a6 100755 (executable)
@@ -347,15 +347,15 @@ esac
 
 ###### link files
 # convenient to just do all file linking in one place
-s /a/exe/lnf -T /a/bin /b
-s /a/exe/lnf -T /nocow/t /t
+sudo /a/exe/lnf -T /a/bin /b
+sudo /a/exe/lnf -T /nocow/t /t
 if has_p; then
   lnf -T /p/News ~/News
 fi
-s /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
+sudo /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
   /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
 /a/bin/ds/install-my-scripts # needed for rootsshsync cronjob
-s /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
+sudo /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 
 
 
@@ -366,7 +366,7 @@ case $(distro-name) in
   arch)
     # pkgfile is like apt-cache
     pi pkgfile
-    s pkgfile --update
+    sudo pkgfile --update
     ;;
 esac
 
@@ -384,8 +384,8 @@ fi
 
 ##### make extra dirs
 dirs=(/mnt/{1,2,3,4,5,6,7,8,9} /nocow/t)
-s mkdir -p "${dirs[@]}"
-s chown $USER:$USER  "${dirs[@]}"
+sudo mkdir -p "${dirs[@]}"
+sudo chown $USER:$USER  "${dirs[@]}"
 
 ###### setup /i
 if home_network; then
@@ -394,8 +394,8 @@ if home_network; then
 /i/k  /k  none  bind,noauto  0 0
 EOF
   if ! mountpoint /kr; then
-    s mkdir -p /kr
-    s chown $USER:user2 /kr
+    sudo mkdir -p /kr
+    sudo chown $USER:user2 /kr
   fi
   if [[ $HOSTNAME == frodo ]]; then
     tu /etc/fstab <<'EOF'
@@ -406,14 +406,14 @@ EOF
 frodo:/k  /kr  nfs  noauto  0 0
 EOF
   fi
-  s mkdir -p /q /i/{w,k}
+  sudo mkdir -p /q /i/{w,k}
   for dir in /{i,w,k}; do
     if mountpoint $dir; then continue; fi # already mounted
-    s mkdir -p $dir
-    s chown $USER:$USER $dir
+    sudo mkdir -p $dir
+    sudo chown $USER:$USER $dir
   done
   # not needed for all hosts, but rather just keep it uniform
-  s mkdir -p /mnt/iroot
+  sudo mkdir -p /mnt/iroot
   # debian auto mounting of multi-disk encrypted btrfs is busted.  It is
   # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
   # based on 3 of those, it creates .device units for /dev/mapper/dev...
@@ -421,7 +421,7 @@ EOF
   # have already been created and exist. todo: create a simple repro
   # for this in a vm and report it upstream.
   pi nfs-common
-  s dd of=/root/imount <<'EOF'
+  sudo dd of=/root/imount <<'EOF'
 #!/bin/bash
 [[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 set -eE -o pipefail
@@ -437,8 +437,8 @@ for dir in /i /mnt/iroot /k /kr /w; do
     fi
 done
 EOF
-  s chmod +x /root/imount
-  s dd of=/etc/systemd/system/imount.service <<EOF
+  sudo chmod +x /root/imount
+  sudo dd of=/etc/systemd/system/imount.service <<EOF
 [Unit]
 Description=Mount /i and related mountpoints
 Before=syncthing@$USER.service
@@ -468,18 +468,18 @@ if has_btrfs; then
   if ! mountpoint $dir; then
     subvol=/mnt/root/nocow
     if [[ ! -e $subvol ]]; then
-      s btrfs subvolume create $subvol
-      s chown root:1000 $subvol
-      s chattr +C $subvol
+      sudo btrfs subvolume create $subvol
+      sudo chown root:1000 $subvol
+      sudo chattr +C $subvol
     fi
 
     first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
     tu /etc/fstab <<EOF
 $first_root_crypt  /nocow  btrfs  noatime,subvol=nocow  0 0
 EOF
-    s mkdir -p $dir
-    s chown $USER:$USER $dir
-    s mount $dir
+    sudo mkdir -p $dir
+    sudo chown $USER:$USER $dir
+    sudo mount $dir
   fi
 else
   sudo mkdir -p $dir
@@ -492,7 +492,7 @@ mail-setup
 #### ubuntu nicety
 if isubuntu; then
   # disable crash report annoying dialogs.
-  s dd of=/etc/default/apport <<<'enabled=0'
+  sudo dd of=/etc/default/apport <<<'enabled=0'
 fi
 
 
@@ -560,10 +560,10 @@ EOF
     # todo, figure this out for arch if we ever try out gnome.
     # install for multiple display managers in case we use one
     dir=/etc/gdm3
-    s mkdir -p $dir/PostLogin
-    s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
-    s mkdir /etc/lightdm/lightdm.conf.d
-    s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
+    sudo mkdir -p $dir/PostLogin
+    sudo command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
+    sudo mkdir /etc/lightdm/lightdm.conf.d
+    sudo dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
 [SeatDefaults]
 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
 EOF
@@ -577,7 +577,7 @@ if has_wayland; then
   # originally used xkbcomp, documented in input-setup.sh, this doesnt
   # work under wayland, but its still useful for creating the config,
   # then modifying the system files.
-  s sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
+  sudo sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
 fi
 
 ##### basic graphical packages
index a057d779b672c992f2707b855316975d819fcd09..1b72e2ea0fc53a8abbccd5f5d1e6b64b2dd288bc 100755 (executable)
@@ -32,19 +32,19 @@ end() {
   echo 0 >~/.local/distro-end
   if $pending_reboot; then
     echo "$0: pending reboot and then finished. doing it now."
-    s reboot now
+    sudo reboot now
   else
     echo "$0: $(date): ending now)"
   fi
   exit 0
 }
 pre="${0##*/}:"
-s() {
-  printf "s %s\n" "$*"
-  SUDOD="$PWD" sudo -i "$@";
+sudo() {
+  printf "$pre %s\n"  "$*"
+  SUDOD="$PWD" command sudo "$@";
 }
 sd() {
-  s dd of="$1" 2>/dev/null
+  sudo dd of="$1" 2>/dev/null
 }
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
@@ -54,9 +54,9 @@ codename=$(debian-codename)
 codename_compat=$(debian-codename-compat)
 pending_reboot=false
 sed="sed --follow-symlinks"
-# template
-case $distro in
-esac
+## template:
+case $distro in
+esac
 
 #### initial packages
 pup
@@ -65,7 +65,7 @@ if isdeb; then
 fi
 
 # avoid prompts
-s debconf-set-selections <<EOF
+sudo debconf-set-selections <<EOF
 popularity-contest popularity-contest/participate boolean true
 EOF
 
@@ -79,7 +79,7 @@ conflink
 if isdeb && pcheck apt-file; then
   # this condition is just a speed optimization
   pi apt-file
-  s apt-file update
+  sudo apt-file update
 fi
 
 
@@ -91,12 +91,12 @@ case $distro in
     # i'd rather disable the service than comment the init file
     # this says disabling the service, it will still get restarted
     # but this script doesn't do anything on restart, so it should be fine
-    s truncate -s0 /var/run/motd.dynamic
+    sudo truncate -s0 /var/run/motd.dynamic
     ;;
   trisquel|ubuntu)
     # this isn't a complete solution. It still shows me when updates are available,
     # but it's no big deal.
-    s rm -fv /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
+    sudo rm -fv /etc/update-motd.d/10-help-text /etc/update-motd.d/00-header
     ;;
 esac
 
@@ -113,7 +113,7 @@ elif [[ $codename_compat == xenial ]]; then
   pi software-properties-common
   l="deb http://ppa.launchpad.net/certbot/certbot/ubuntu xenial main"
   if ! grep -xFq "$l" /etc/apt/sources.list{,.d/*.list}; then
-    s add-apt-repository -y ppa:certbot/certbot ||:
+    sudo add-apt-repository -y ppa:certbot/certbot ||:
     m p update
   fi
   pi python-certbot-apache
@@ -129,7 +129,7 @@ $sed -r -f - /lib$x.service <<'EOF' |sd /etc${x}mail.service
 s,(ExecStart=)(/usr/bin/certbot),\1/a/bin/log-quiet/sysd-mail-once certbotmail \2 --renew-hook /a/bin/distro-setup/certbot-renew-hook,
 EOF
 ser daemon-reload
-sgo certbotmail.timer
+sgo certbotmail.timer
 ### end certbot install ###
 
 
@@ -188,7 +188,7 @@ deb http://us.archive.ubuntu.com/ubuntu/ xenial-security main
 EOF
 
     if ! apt-key list | grep /C0B21F32 &>/dev/null; then
-      s apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
+      sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 3B4FE6ACC0B21F32
       sd /etc/apt/preferences.d/flidas-bionic <<EOF
 Package: *
 Pin: release a=bionic
@@ -229,8 +229,8 @@ deb http://us.archive.ubuntu.com/ubuntu/ bionic-security main
 EOF
     f=/etc/apt/sources.list.d/bionic.list
     if ! diff -q $t $f; then
-      s cp $t $f
-      s chmod 644 $f
+      sudo cp $t $f
+      sudo chmod 644 $f
       m p update
     fi
 
@@ -243,7 +243,7 @@ EOF
       cd $t
       m aptitude download debootstrap/xenial
       m ex ./*
-      s cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
+      sudo cp ./usr/share/debootstrap/scripts/* /usr/share/debootstrap/scripts
     fi
 
     sd /etc/apt/preferences.d/flidas-etiona <<EOF
@@ -273,7 +273,7 @@ deb http://mirror.fsf.org/trisquel/ etiona-backports main
 EOF
     f=/etc/apt/sources.list.d/etiona.list
     if ! diff -q $t $f; then
-      s cp $t $f
+      sudo cp $t $f
       n s chmod 644 $f
       m p update
     fi
@@ -298,14 +298,14 @@ EOF
     # dont use buster because it causes dist-upgrade to think its downgrading
     # packages while really just reinstalling the same version.
     f=/etc/apt/apt.conf.d/01iank
-    s rm -fv $f
+    sudo rm -fv $f
     #         # stupid buster uses some key algorithm not supported by flidas gpg that apt uses.
     #         sd /etc/apt/apt.conf.d/01iank <<'EOF'
     # Acquire::AllowInsecureRepositories "true";
     # EOF
 
     f=/etc/apt/sources.list.d/buster.list
-    s rm -fv $f
+    sudo rm -fv $f
     #         t=$(mktemp)
     #         cat >$t <<EOF
     # deb http://http.us.debian.org/debian buster main
@@ -389,7 +389,7 @@ Unattended-Upgrade::Origins-Pattern {
 EOF
 
 # old names, too verbose
-s rm -f /etc/cron.d/unattended-upgrade-reboot /usr/local/bin/zelous-unattended-reboot
+sudo rm -f /etc/cron.d/unattended-upgrade-reboot /usr/local/bin/zelous-unattended-reboot
 
 sd /etc/cron.d/myupgrade <<'EOF'
 # Setup reboots when running outdated stuff, unattended upgrades happen
@@ -413,15 +413,15 @@ case $HOSTNAME in
     f=/var/lib/bind/db.b8.nz
     if [[ ! -e $f ]]; then
       ser stop bind9
-      s rm -fv $f.jnl
-      s install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
+      sudo rm -fv $f.jnl
+      sudo install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
       ser restart bind9
     fi
     ;;&
   l2)
     # setup let's encrypt cert
     m web-conf apache2 l2.b8.nz
-    s rm -fv /etc/apache2/sites-enabled/l2.b8.nz{,-redir}.conf
+    sudo rm -fv /etc/apache2/sites-enabled/l2.b8.nz{,-redir}.conf
     ser reload apache2
     s lnf -T /etc/letsencrypt/live/l2.b8.nz/fullchain.pem /etc/exim4/exim.crt
     if [[ ! -L /etc/exim4/exim.key ]]; then
@@ -445,13 +445,13 @@ case $HOSTNAME in
 
     # start mumble only when im going to use it, since i dont use it much
     pi-nostart mumble-server
-    s $sed -ri "s/^ *(serverpassword=).*/\1$(< /a/bin/bash_unpublished/mumble_pass)/" /etc/mumble-server.ini
+    sudo $sed -ri "s/^ *(serverpassword=).*/\1$(< /a/bin/bash_unpublished/mumble_pass)/" /etc/mumble-server.ini
 
     # do certificate to avoid warning about unsigned cert,
     # which is overkill for my use, but hey, I'm cool, I know
     # how to do this.
     m web-conf apache2 mumble.iankelling.org
-    s rm -fv /etc/apache2/sites-enabled/mumble.iankelling.org
+    sudo rm -fv /etc/apache2/sites-enabled/mumble.iankelling.org
     s <<'EOF'
 export RENEWED_LINEAGE=/etc/letsencrypt/live/mumble.iankelling.org
 /a/bin/distro-setup/certbot-renew-hook
@@ -467,7 +467,7 @@ EOF
     # and man openvpn
 
     m vpn-server-setup -rd 2600:3c00:e000:280::1/64 2600:3c00::f03c:91ff:feb4:0bf3
-    s tee /etc/openvpn/client-config/mail <<'EOF'
+    sudo tee /etc/openvpn/client-config/mail <<'EOF'
 ifconfig-push 10.8.0.4 255.255.255.0
 ifconfig-ipv6-push 2600:3c00:e000:280::2/64
 EOF
@@ -492,13 +492,13 @@ ExecStop=/a/bin/distro-setup/vpn-mail-forward stop
 WantedBy=$vpn_service.service
 EOF
     ser daemon-reload
-    sgo vpnmail.service
+    sgo vpnmail.service
     # needed for li's local mail delivery.
     tu /etc/hosts <<<"10.8.0.4 mail.iankelling.org"
-    sgo $vpn_service
+    sgo $vpn_service
     # setup let's encrypt cert
     m web-conf apache2 mail.iankelling.org
-    s rm -fv /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
+    sudo rm -fv /etc/apache2/sites-enabled/mail.iankelling.org{,-redir}.conf
     ser reload apache2
 
     domain=cal.iankelling.org
@@ -528,7 +528,7 @@ EOF
     # to get into the web interface,
     # then use non-main browser or else it doebsn't allow it based on ocsp stapling from my main site.
     # https://iankelling.org:12533/
-    sudo -i <<'EOF'
+    s <<'EOF'
 export RENEWED_LINEAGE=/etc/letsencrypt/live/iankelling.org
 /a/bin/distro-setup/certbot-renew-hook
 EOF
@@ -566,13 +566,16 @@ EOF
     # https://wiki.znc.in/self-message
     # https://wiki.znc.in/Query_buffers                                                \
       #
-    s useradd --create-home -d /var/lib/znc --system --shell /sbin/nologin --comment "Account to run ZNC daemon" --user-group znc || [[ $? == 9 ]] # 9 if it exists already
-    s chmod 700 /var/lib/znc
-    s chown -R znc:znc /var/lib/znc
+    if ! getent passwd znc > /dev/null; then
+      sudo useradd --create-home -d /var/lib/znc --system --shell /sbin/nologin --comment "Account to run ZNC daemon" --user-group znc
+    fi
+    sudo chmod 700 /var/lib/znc
+    sudo chown -R znc:znc /var/lib/znc
     # Avoid restarting if possible, reconnecting to irc is annoying.
     # The unit file was made active with conflink.
-    if [[ $(ser is-active znc) != active ]]; then
-      m sgo znc
+    # Note, avoid using ser here because we wrap sudo to prints the command first.
+    if [[ $(systemctl is-active znc) != active ]]; then
+      sgo znc
     fi
     ###### stop znc setup #####
 
@@ -611,11 +614,11 @@ esac
 pi ${pall[@]} $(apt-cache search ruby[.0-9]+-doc| awk '{print $1}') $(apt-cache depends gcc|grep -i suggests:| awk '{print $2}') $($src/distro-pkgs)
 
 
-sgo fsf-vpn-dns-cleanup
+sgo fsf-vpn-dns-cleanup
 
 
 # website is dead june 14 2019. back in october, but meh
-s rm -fv /etc/apt/sources.list.d/iridium-browser.list
+sudo rm -fv /etc/apt/sources.list.d/iridium-browser.list
 # case $distro in
 #   debian)
 #     pi chromium ;;
@@ -659,12 +662,12 @@ s rm -fv /etc/apt/sources.list.d/iridium-browser.list
 
 # key already exists, so this won't generate one, just the configs.
 m vpn-server-setup -rds
-s tee -a /etc/openvpn/server/server.conf <<'EOF'
+sudo tee -a /etc/openvpn/server/server.conf <<'EOF'
 push "dhcp-option DNS 10.0.0.1"
 push "route 10.0.0.0 255.255.0.0"
 client-connect /a/bin/distro-setup/vpn-client-connect
 EOF
-s sed -i --follow-symlinks 's/10.8./10.9./g;s/^\s*port\s.*/port 1196/' /etc/openvpn/server/server.conf
+sudo sed -i --follow-symlinks 's/10.8./10.9./g;s/^\s*port\s.*/port 1196/' /etc/openvpn/server/server.conf
 
 if [[ $HOSTNAME == tp ]]; then
   if [[ -e /lib/systemd/system/openvpn-server@.service ]]; then
@@ -672,7 +675,7 @@ if [[ $HOSTNAME == tp ]]; then
   else
     vpn_service=openvpn@server
   fi
-  sgo $vpn_service
+  sgo $vpn_service
 fi
 ### end vpn server setup
 
@@ -706,7 +709,7 @@ OnUnitInactiveSec=300
 [Install]
 WantedBy=timers.target
 EOF
-s systemctl daemon-reload
+sudo systemctl daemon-reload
 
 
 ######### begin  pump.io periodic backup #############
@@ -732,7 +735,7 @@ OnCalendar=hourly
 WantedBy=timers.target
 EOF
   ser daemon-reload
-  sgo pumpbackup.timer
+  sgo pumpbackup.timer
 fi
 #########  end  pump.io periodic backup #############
 
@@ -759,7 +762,7 @@ OnCalendar=hourly
 [Install]
 WantedBy=timers.target
 EOF
-  s systemctl daemon-reload
+  sudo systemctl daemon-reload
   sgo ircbackup.timer
 fi
 
@@ -805,7 +808,7 @@ if [[ $HOSTNAME == frodo ]]; then
   pi syncthing
   m lnf -T /w/syncthing /home/iank/.config/syncthing
   ser daemon-reload # syncthing likely not properly packaged
-  sgo syncthing@iank # runs as iank
+  sgo syncthing@iank # runs as iank
 
   # these things persist in ~/.config/syncthing, which I save in
   # /w/syncthing (not in /p, because syncthing should continue to
@@ -890,7 +893,7 @@ fi
 pi libswitch-perl libdigest-md5-file-perl libgnupg-interface-perl
 t=$(mktemp)
 m wget -O $t http://mirror.fsf.org/fsfsys-trisquel/fsfsys-trisquel/pool/main/s/spd-perl/spd-perl_0.2-1_amd64.deb
-s dpkg -i $t
+sudo dpkg -i $t
 m rm $t
 # this guesses at the appropriate directory, adjust if needed
 perldir=(/usr/lib/x86_64-linux-gnu/perl/5.*)
@@ -898,7 +901,7 @@ m sudo ln -sf ../../../perl/5.18.2/SPD/ ${perldir[0]}
 # newer distro had gpg2 as default, older one, flidas, need to make it that way
 gpgpath=$(which gpg2)
 if [[ $x ]]; then
-  s mkdir -p /usr/local/spdhackfix
+  sudo mkdir -p /usr/local/spdhackfix
   s lnf -T $gpgpath /usr/local/spdhackfix/gpg
 fi
 ### end spd install
@@ -981,16 +984,16 @@ preserve-environment=true
 users=$USER,user2
 EOF
   if [[ -e $d/bin ]]; then
-    s chroot $d apt-get update
-    s chroot $d apt-get -y dist-upgrade --purge --auto-remove
-    cd; s schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
+    sudo chroot $d apt-get update
+    sudo chroot $d apt-get -y dist-upgrade --purge --auto-remove
+    cd; sudo schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
   else
-    s mkdir -p $d
+    sudo mkdir -p $d
 
-    s debootstrap $n $d $repo
-    cd; s schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
+    sudo debootstrap $n $d $repo
+    cd; sudo schroot -c $n -- apt-get install --allow-unauthenticated -y ${apps[@]}
   fi
-  s cp -P {,$d}/etc/localtime
+  sudo cp -P {,$d}/etc/localtime
 }
 sd /etc/systemd/system/schrootupdate.service <<'EOF'
 [Unit]
@@ -1012,7 +1015,7 @@ OnCalendar=*-*-* 04:20:00
 WantedBy=timers.target
 EOF
 ser daemon-reload
-sgo schrootupdate.timer
+sgo schrootupdate.timer
 
 
 
@@ -1026,8 +1029,8 @@ case $distro in
     ;;
 esac
 
-s mkdir -p /nocow/user
-s chown $USER:$USER /nocow/user
+sudo mkdir -p /nocow/user
+sudo chown $USER:$USER /nocow/user
 pi anki
 
 
@@ -1046,21 +1049,21 @@ esac
 # 450 seems likely to be unused. we need to specify one or else
 # it won't be stable across installs.
 if ! getent passwd debian-transmission > /dev/null; then
-  s groupadd -g 450 debian-transmission
-  s adduser --quiet \
-    --gid 450 \
-    --uid 450 \
-    --system \
-    --no-create-home \
-    --disabled-password \
-    --home /var/lib/transmission-daemon \
-    debian-transmission
+  sudo groupadd -g 450 debian-transmission
+  sudo adduser --quiet \
+       --gid 450 \
+       --uid 450 \
+       --system \
+       --no-create-home \
+       --disabled-password \
+       --home /var/lib/transmission-daemon \
+       debian-transmission
 fi
 # We want group writable stuff from transmission.
 # However, after setting this, I learn that transmission sets it's
 # own umask based on it's settings file. Well, no harm leaving this
 # so it's set right from the beginning.
-s chfn debian-transmission -o umask=0002
+sudo chfn debian-transmission -o umask=0002
 
 # note i had to do this, which is persistent:
 # cd /i/k
@@ -1073,7 +1076,7 @@ tu /etc/sysctl.conf<<'EOF'
 net.core.rmem_max = 67108864
 net.core.wmem_max = 16777216
 EOF
-s sysctl -p
+sudo sysctl -p
 
 # some reason it doesn\'t seem to start automatically anyways
 pi-nostart transmission-daemon
@@ -1090,13 +1093,13 @@ f=$tdir/transmission-daemon
 mkdir -p $f
 s lnf -T $f /var/lib/transmission-daemon/.config/transmission-daemon
 s lnf -T /etc/transmission-daemon/settings.json $f/settings.json
-s chown -R debian-transmission:debian-transmission $f
+sudo chown -R debian-transmission:debian-transmission $f
 for f in $tdir/partial-torrents $tdir/torrents; do
   if [[ -e $f ]]; then
-    s chown -R debian-transmission:user2 $f
+    sudo chown -R debian-transmission:user2 $f
   fi
 done
-s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
+sudo chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
 #
 # config file documented here, and it\'s the same config
 # for daemon vs client, so it\'s documented in the gui.
@@ -1108,7 +1111,7 @@ s chown -R debian-transmission:debian-transmission /var/lib/transmission-daemon
 #
 # Changed the cache-size to 256 mb, reduces disk use.
 # It is a read & write cache.
-s ruby <<EOF
+sudo ruby <<EOF
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 File.write(p, JSON.pretty_generate(JSON.parse(File.read(p)).merge({
@@ -1158,7 +1161,7 @@ EOF
 ser daemon-reload
 
 if [[ $HOSTNAME == frodo ]]; then
-  sgo transmission-daemon-nn
+  sgo transmission-daemon-nn
 fi
 
 
@@ -1178,7 +1181,7 @@ if [[ -e /p/transmission-rpc-pass ]]; then
 
   # the password is randomly generated on first run, i copied it out
   # so it could be used by other hosts.
-  s ruby <<'EOF'
+  sudo ruby <<'EOF'
 require 'json'
 p = '/etc/transmission-daemon/settings.json'
 s = JSON.parse(File.read(p))
@@ -1196,8 +1199,8 @@ EOF
       continue
     fi
     d=$f/.config/transmission-remote-gtk
-    s -u $u mkdir -p $d
-    s -u $u dd of=$d/config.json <<EOF
+    sudo -u $u mkdir -p $d
+    sudo -u $u dd of=$d/config.json <<EOF
 {
   "profiles" : [
       {
@@ -1251,7 +1254,7 @@ fi
 
 ### printer setup
 pi cups hplip
-s gpasswd -a $USER lpadmin # based on ubuntu wiki
+sudo gpasswd -a $USER lpadmin # based on ubuntu wiki
 # goto http://127.0.0.1:631
 # administration tab, add new printer button.
 # In debian, I could use hte recommended driver,
@@ -1302,12 +1305,12 @@ pi --no-install-recommends kdeconnect
 # also built latest arduino in /a/opt/Arduino, (just cd build; ant build; ant run )
 # set arduino var in bashrc,
 # have system config file setup too.
-s adduser $USER dialout
+sudo adduser $USER dialout
 
 # this is for the mail command too. update-alternatives is kind of misleading
 # since at least it's main commands pretend mail does not exist.
 # bsd's mail got pulled in on some dumb dependency, i dunno how.
-s update-alternatives --set mailx /usr/bin/mail.mailutils
+sudo update-alternatives --set mailx /usr/bin/mail.mailutils
 
 ######### end misc packages #########
 
@@ -1332,7 +1335,7 @@ pi smartmontools
 # -o on, turn on 4 hour period non-performance degrading testing.
 # short test daily 2-3am, extended tests Saturdays between 3-4am:
 sched="-s (S/../.././02|L/../../6/03)"
-s sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
+sudo sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
 DEVICESCAN -a -o on -S on -n standby,q $sched \
 -m ian@iankelling.org -M exec /usr/local/bin/smart-notify#" /etc/smartd.conf
 
@@ -1356,8 +1359,8 @@ DEVICESCAN -a -o on -S on -n standby,q $sched \
 # conflicts with the normal dnsmasq package.
 f=/etc/NetworkManager/NetworkManager.conf
 m=$(md5sum $f)
-s sed -ri '/ *\[main\]/,/^ *\[[^]]+\]/{/^\s*dns[[:space:]=]/d}' $f
-s sed -ri '/ *\[main\]/a dns=default' $f
+sudo sed -ri '/ *\[main\]/,/^ *\[[^]]+\]/{/^\s*dns[[:space:]=]/d}' $f
+sudo sed -ri '/ *\[main\]/a dns=default' $f
 if [[ $m != $(md5sum $f) ]]; then
   srestart NetworkManager
 fi
@@ -1365,12 +1368,12 @@ fi
 # make my /etc/fonts/conf.d/ get used.
 # I have a new sans-serif font there because the default one
 # displays l and I as the same char, grrrrr.
-s fc-cache
+sudo fc-cache
 
 m /a/bin/distro-setup/mymimes
 
 
-sgo dynamicipupdate
+sgo dynamicipupdate
 
 
 # stop autopoping windows when i plug in an android phone.
@@ -1386,7 +1389,7 @@ for dev in $(s btrfs fil show /boot | sed -nr 's#.*path\s+(\S+)$#\1#p'); do
   devs+=("$(devbyid $dev),")
 done
 devs[-1]=${devs[-1]%,} # jonied by commas
-s debconf-set-selections <<EOF
+sudo debconf-set-selections <<EOF
 grub-pc grub-pc/install_devices multiselect ${devs[*]}
 EOF
 
@@ -1396,9 +1399,9 @@ sgo btrfsmaintstop.timer
 
 # aren't autoupdating this, but I do check on it somewhat regularly.
 m cd /a/opt/btrbk
-s make install
+sudo make install
 
-sgo btrbk.timer
+sgo btrbk.timer
 # note: to see when it was last run,
 # ser list-timers
 
@@ -1411,7 +1414,7 @@ EOF
 # Remove dep that came in with desktop to fix associations.
 m pu transmission-gtk
 
-s gpasswd -a iank adm #needed for reading logs
+sudo gpasswd -a iank adm #needed for reading logs
 
 m /a/bin/buildscripts/pithosfly
 
@@ -1459,7 +1462,7 @@ if [[ $HOSTNAME == frodo ]]; then
   tu /etc/exports <<'EOF'
 /k 10.0.0.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)
 EOF
-  s exportfs -rav
+  sudo exportfs -rav
 fi
 
 
index e589f15dddfbc5765f4f3684d8cf12e310383937..db139d4f5347aaa5ec7ba782c776f5f9f77a8b47 100755 (executable)
@@ -90,9 +90,9 @@ exit
 # # note, conflink also does some group ownership stuff.
 
 mkc /p/c/machine_specific/linode/filesystem/etc/bind
-s dnssec-keygen -a HMAC-SHA512 -b 512 -n HOST b8.nz
+sudo dnssec-keygen -a HMAC-SHA512 -b 512 -n HOST b8.nz
 user=$(id -un)
-s chown $user:$user *
+sudo chown $user:$user *
 
 
 f=key.b8.nz
index 747e2a6604542ed4894ce3e68fbf18174c0401df..430f8061c1c6611eafea56f369211c46d8804f94 100644 (file)
@@ -88,9 +88,9 @@ write-status() {
       if [[ -e $f ]]; then
         now=$(date +%s)
         fsec=$(stat -c%Y $f)
-        # the / 60 makes it 0-59 seconds less strict, +1 makes sure we
+        # the / 60 makes it 0-59 seconds less strict, +1 to help make sure we
         # dont have any false positives.
-        fmin=$(( (fsec - now ) / 60 + 1 ))
+        fmin=$(( (fsec - now + 1 ) / 60 ))
         fminplus=$(( fmin + 60*24 ))
         # Filesystem files get copied, so find any newer than the last run.
         # The rest are hueristics:
@@ -104,8 +104,8 @@ write-status() {
           if grep -qxF $HOSTNAME $x; then all_dirs+=( ${x%.hosts} ); fi
         done
 
-        # just because i forget a lot, -mmin -NUM means files modified <= NUM minutes ago
-        if   [[ $(find ${all_dirs[@]} -mmin $fmin -type f -print -quit 2>/dev/null) ]]; then
+        # Just because i forget a lot, -mmin -NUM means files modified <= NUM minutes ago
+        if (( fmin < 0 )) && [[ $(find ${all_dirs[@]} -mmin $fmin -type f -print -quit 2>/dev/null) ]]; then
           v conflink newer filesystem files
           chars+=("CONFLINK!")
           break